var gOz = new Object();
var gSelectedState;
var gSelectedTown;
var gCheckDate;

function getPrefs() {
    if (!widget.preferenceForKey("ozSelectedState")) {
	widget.setPreferenceForKey("VIC", "ozSelectedState"); // default
	widget.setPreferenceForKey("Melbourne", "ozSelectedTown"); // default
    }
    gSelectedState = widget.preferenceForKey("ozSelectedState");
    gSelectedTown = widget.preferenceForKey("ozSelectedTown");

    /*********************************************************************
    * NOTE - the Weather4Oz program called below is
    * Copyright  R&D Specialised Software Pty Ltd 2005. All Rights Reserved.
    * and may not by used without permission
    **********************************************************************/
    var prefCall = "./Weather4Oz " + gSelectedState + " \"" +
    gSelectedTown + "\"";
    var oz = widget.system(prefCall, null).outputString;
    eval("gOz = " + oz + ";");

    if (gOz.errMess == "OK") {
	widget.setPreferenceForKey(gOz.errMess,"ozErrMess");
	widget.setPreferenceForKey(gOz.issueDay,"ozIssueDay");
	widget.setPreferenceForKey(gOz.issueTime,"ozIssueTime");
	widget.setPreferenceForKey(gOz.icon0,"ozIcon0");
	widget.setPreferenceForKey(gOz.icon1,"ozIcon1");
	widget.setPreferenceForKey(gOz.icon2,"ozIcon2");
	widget.setPreferenceForKey(gOz.icon3,"ozIcon3");
	widget.setPreferenceForKey(gOz.day0,"ozDay0");
	widget.setPreferenceForKey(gOz.day1,"ozDay1");
	widget.setPreferenceForKey(gOz.day2,"ozDay2");
	widget.setPreferenceForKey(gOz.day3,"ozDay3");
	widget.setPreferenceForKey(gOz.temp0,"ozTemp0");
	widget.setPreferenceForKey(gOz.temp1,"ozTemp1");
	widget.setPreferenceForKey(gOz.temp2,"ozTemp2");
	widget.setPreferenceForKey(gOz.temp3,"ozTemp3");
	widget.setPreferenceForKey(gOz.forecast0,"ozForecast0");
	widget.setPreferenceForKey(gOz.forecast1,"ozForecast1");
	widget.setPreferenceForKey(gOz.forecast2,"ozForecast2");
	widget.setPreferenceForKey(gOz.forecast3,"ozForecast3");
    }
    else    // if error and no earlier preferences exist, initialize them
    if (!widget.preferenceForKey("ozIssueDay")) {
	widget.setPreferenceForKey(gOz.errMess,"ozErrMess");
	widget.setPreferenceForKey(" ","ozIssueDay");
	widget.setPreferenceForKey(" ","ozIssueTime");
	widget.setPreferenceForKey(" ","ozIcon0");
	widget.setPreferenceForKey(" ","ozIcon1");
	widget.setPreferenceForKey(" ","ozIcon2");
	widget.setPreferenceForKey(" ","ozIcon3");
	widget.setPreferenceForKey(" ","ozDay0");
	widget.setPreferenceForKey(" ","ozDay1");
	widget.setPreferenceForKey(" ","ozDay2");
	widget.setPreferenceForKey(" ","ozDay3");
	widget.setPreferenceForKey(" ","ozTemp0");
	widget.setPreferenceForKey(" ","ozTemp1");
	widget.setPreferenceForKey(" ","ozTemp2");
	widget.setPreferenceForKey(" ","ozTemp3");
	widget.setPreferenceForKey(" ","ozForecast0");
	widget.setPreferenceForKey(" ","ozForecast1");
	widget.setPreferenceForKey(" ","ozForecast2");
	widget.setPreferenceForKey(" ","ozForecast3");
	widget.setPreferenceForKey("VIC", "ozSelectedState"); // default
	widget.setPreferenceForKey("Melbourne", "ozSelectedTown"); // default
    }
    gOz.errMess = widget.preferenceForKey("ozErrMess");
    gOz.issueDay = widget.preferenceForKey("ozIssueDay");
    gOz.issueTime = widget.preferenceForKey("ozIssueTime");
    gOz.icon0 = widget.preferenceForKey("ozIcon0");
    gOz.icon1 = widget.preferenceForKey("ozIcon1");
    gOz.icon2 = widget.preferenceForKey("ozIcon2");
    gOz.icon3 = widget.preferenceForKey("ozIcon3");
    gOz.day0 = widget.preferenceForKey("ozDay0");
    gOz.day1 = widget.preferenceForKey("ozDay1");
    gOz.day2 = widget.preferenceForKey("ozDay2");
    gOz.day3 = widget.preferenceForKey("ozDay3");
    gOz.temp0 = widget.preferenceForKey("ozTemp0");
    gOz.temp1 = widget.preferenceForKey("ozTemp1");
    gOz.temp2 = widget.preferenceForKey("ozTemp2");
    gOz.temp3 = widget.preferenceForKey("ozTemp3");
    gOz.forecast0 = widget.preferenceForKey("ozForecast0");
    gOz.forecast1 = widget.preferenceForKey("ozForecast1");
    gOz.forecast2 = widget.preferenceForKey("ozForecast2");
    gOz.forecast3 = widget.preferenceForKey("ozForecast3");
    if (!widget.preferenceForKey("ozSelectedState")) {
	widget.setPreferenceForKey("VIC", "ozSelectedState"); // default
	widget.setPreferenceForKey("Melbourne", "ozSelectedTown"); // default
    }
    gSelectedState = widget.preferenceForKey("ozSelectedState");
    gSelectedTown = widget.preferenceForKey("ozSelectedTown");
}

function showBack()
{
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    if (window.widget)
    widget.prepareForTransition("ToBack");
    front.style.display="none";
    back.style.display="block";
    if (window.widget)
    setTimeout ('widget.performTransition();', 0);
}


function hideBack()
{
    setWeather();
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    if (window.widget)
	widget.prepareForTransition("ToFront");
    back.style.display="none";
    front.style.display="block";
    document.getElementById('fliprollie').style.display = 'none';
    if (window.widget)
	setTimeout ('widget.performTransition();', 0);
}

var flipShown = false;

var animation = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0,
	firstElement:null, timer:null};

function mousemove (event)
{
    if (!flipShown)
    {
    if (animation.timer != null)
    {
	clearInterval (animation.timer);
	animation.timer	 = null;
    }

    var starttime = (new Date).getTime() - 13;

    animation.duration = 500;
    animation.starttime = starttime;
    animation.firstElement = document.getElementById ('flip');
    animation.timer = setInterval ("animate();", 13);
    animation.from = animation.now;
    animation.to = 1.0;
    animate();
    flipShown = true;
    }
}

function mouseexit (event)
{
    if (flipShown)
    {
    // fade in the info button
    if (animation.timer != null)
    {
	clearInterval (animation.timer);
	animation.timer	 = null;
    }
    var starttime = (new Date).getTime() - 13;
    animation.duration = 500;
    animation.starttime = starttime;
    animation.firstElement = document.getElementById ('flip');
    animation.timer = setInterval ("animate();", 13);
    animation.from = animation.now;
    animation.to = 0.0;
    animate();
    flipShown = false;
    }
}

var note1Shown = false;
function mmove1 (event)
{
    if (!note1Shown) {
	var item = document.getElementById ('note1');
	if (gOz.forecast0 != "") {
	    item.style.opacity = 0.8;
	    note1Shown = true;
	}
    }
}

function mexit1 (event)
{
    if (note1Shown) {
	var item = document.getElementById ('note1');
	item.style.opacity = 0.0;
	note1Shown = false;
    }
}

var note2Shown = false;
function mmove2 (event)
{
    if (!note2Shown) {
	var item = document.getElementById ('note2');
	if (gOz.forecast1 != "") {
	    item.style.opacity = 0.8;
	    note2Shown = true;
	}
    }
}

function mexit2 (event)
{
    if (note2Shown) {
	var item = document.getElementById ('note2');
	item.style.opacity = 0.0;
	note2Shown = false;
    }
}

var note3Shown = false;
function mmove3 (event)
{
    if (!note3Shown) {
	var item = document.getElementById ('note3');
	if (gOz.forecast2 != "") {
	    item.style.opacity = 0.8;
	    note3Shown = true;
	}
    }
}

function mexit3 (event)
{
    if (note3Shown) {
	var item = document.getElementById ('note3');
	item.style.opacity = 0.0;
	note3Shown = false;
    }
}

var note4Shown = false;
function mmove4 (event)
{
    if (!note4Shown) {
	var item = document.getElementById ('note4');
	if (gOz.forecast3 != "") {
	    item.style.opacity = 0.8;
	    note4Shown = true;
	}
    }
}

function mexit4 (event)
{
    if (note4Shown) {
	var item = document.getElementById ('note4');
	item.style.opacity = 0.0;
	note4Shown = false;
    }
}


function animate()
{
    var T;
    var ease;
    var time = (new Date).getTime();
    T = limit_3(time-animation.starttime, 0, animation.duration);
    if (T >= animation.duration)
    {
    clearInterval (animation.timer);
    animation.timer = null;
    animation.now = animation.to;
    }
    else
    {
    ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
    animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
    animation.firstElement.style.opacity = animation.now;
}

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

function enterflip(event)
{
    document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event)
{
    document.getElementById('fliprollie').style.display = 'none';
}

function setup()
{
}

function loaded() {
    var doneButton = document.getElementById("done");
    createGenericButton (doneButton, "Done", hideBack);
    if (window.widget)
	widget.onshow = onshow;
    setWeather();
    onshow();
}

function changeState(elem)
{
    gSelectedState = elem.value;
    getTowns();
    widget.setPreferenceForKey(gSelectedState, "ozSelectedState");
    // set first town as default after changing state
    gSelectedTown = document.getElementById('locPopup').options[0].value;
    widget.setPreferenceForKey(gSelectedTown, "ozSelectedTown");
}

function changeLoc(elem)
{
    gSelectedTown = elem.value;
    widget.setPreferenceForKey(gSelectedTown, "ozSelectedTown");
}

function getTowns() {
    var tempOz;

    /*********************************************************************
    * NOTE - the Weather4Oz program called below is
    * Copyright  R&D Specialised Software Pty Ltd 2005. All Rights Reserved.
    * and may not by used without permission
    **********************************************************************/
    var townCall = "./Weather4Oz " + gSelectedState + " LISTALL";
    var temp = widget.system(townCall, null).outputString;
    eval("tempOz = " + temp + ";");
    if (tempOz.errMess == "OK") {
	var i;
	towns = "";
	for (i = 0; i < tempOz.towns.length; i++) {
	    if (gSelectedTown == tempOz.towns[i])
		towns = towns + "<option value="
		+ "\"" + tempOz.towns[i] + "\"" +
		" selected='selected'>" + tempOz.towns[i] + "</option>";
	    else
		towns = towns + "<option value="
		+ "\"" + tempOz.towns[i] + "\"" +
		">" + tempOz.towns[i] + "</option>";
	}
    }
    document.getElementById('locPopup').innerHTML = towns;
}

function setWeather() {
    if (window.widget) {
	if (!widget.preferenceForKey("ozSelectedState")) {
	    showBack();
	}
	getPrefs();
	document.getElementById('icon1temp').innerText = gOz.temp0;
	document.getElementById('icon2temp').innerText = gOz.temp1;
	document.getElementById('icon3temp').innerText = gOz.temp2;
	document.getElementById('icon4temp').innerText = gOz.temp3;
	document.getElementById('icon1day').innerText = gOz.day0;
	document.getElementById('icon2day').innerText = gOz.day1;
	document.getElementById('icon3day').innerText = gOz.day2;
	document.getElementById('icon4day').innerText = gOz.day3;
	document.getElementById('note1Text').innerText = gOz.forecast0;
	document.getElementById('note2Text').innerText = gOz.forecast1;
	document.getElementById('note3Text').innerText = gOz.forecast2;
	document.getElementById('note4Text').innerText = gOz.forecast3;
	document.getElementById('sourceText').innerHTML =
	"Forecast for " + gSelectedTown + " <br> issued " + gOz.issueDay
	+ " " + gOz.issueTime;
	if (gOz.icon0)
	document.getElementById('icon1').innerHTML =
	"<img src=" + gOz.icon0 + ">";
	else
	document.getElementById('icon1').innerHTML =
	" ";
	if (gOz.icon1)
	document.getElementById('icon2').innerHTML =
	"<img src=" + gOz.icon1 + ">";
	else
	document.getElementById('icon2').innerHTML =
	" ";
	if (gOz.icon2)
	document.getElementById('icon3').innerHTML =
	"<img src=" + gOz.icon2 + ">";
	else
	document.getElementById('icon3').innerHTML =
	" ";
	if (gOz.icon3)
	document.getElementById('icon4').innerHTML =
	"<img src=" + gOz.icon3 + ">";
	else
	document.getElementById('icon4').innerHTML =
	" ";

	var temp =
	"<option value=VIC>VIC</option>" +
	"<option value=NSW>NSW</option>" +
	"<option value=QLD>QLD</option>" +
	"<option value=SA>SA</option>" +
	"<option value=NT>NT</option>" +
	"<option value=WA>WA</option>" +
	"<option value=TAS>TAS</option>";
	var i = temp.indexOf(gSelectedState);
	var states = temp.substr(0, i - 6) + " selected='selected' " +
	temp.substr(i - 6, temp.length - i + 6);
	document.getElementById('statePopup').innerHTML = states;
	getTowns();

	gCheckDate = new Date();
    }
}

function onshow() {
    var today = new Date();
    var diff = today.getTime() / 1000 - gCheckDate.getTime() / 1000;
    if (diff > (60 * 60)) { // check forecast if older than 1 hour
	setWeather();
	gCheckDate = today;
    }
}
